# Contributing
Thank you for looking into [UDPT](https://github.com/naim94a/udpt)!

This document lists various ways to contribute to UDPT. If you can, please do.

## Bug Reports
Bug reports are always welcome, they help us maintain a quality product.

Before submitting a bug report, please first check that the issue does not already exist and that the effected version
is the most recent one.

* If a similar (or same) issue already exists, please upvote, comment, elaborate on the existing issue.
* If you found a new issue, please attach the used configuration and how to cause the bug to appear.
* Core dumps are always welcome

Bugs should be reported at [UDPT's issue tracker](https://github.com/naim94a/udpt) on GitHub.

## Suggesting new features
New features are welcome, it doesn't mean they will enter immediately.

Suggestions should be filed as issues along with bug reports, just add the "enhancement" label to the created issue.

## Pull requests
Before submitting a pull request, please check that the changes don't effect other platforms or have any unwanted
side-effects.

Pull Requests should address open issue(s), where the project owner and contributors can discuss how the issue should be
addressed.

Pull requests that add new features should be first mentioned in issues in order to verify that the project owner will
allow such changes to the project.

Code in pull requests should meet the following standards:

* Class names should be CamelCase, and the first letter should be capital.
* Functions should be camelCase, and the first letter should be lower-case.
* Class members should be prefixed with `m_`, for example: `bool m_isRunning`
* All variables, classes, functions and class members should have an indicative name.
* Adding external libraries is allowed, but frowned upon
